﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX

	Public meanX As Double 'Mean of x in all pxypoints
	Public meanY As Double 'Mean of y in all pxypoints

	Public Sxx As Double
	Public Syy As Double
	Public Sxy As Double	
	Public Sx As Double
	Public Sy As Double

	Public Beta1ForSimpleLinearRegression As Double
	Public Beta0ForSimpleLinearRegression As Double
	
	Public Beta1FromGeometricMeanRegression As Double
	Public Beta0FromGeometricMeanRegression As Double
	
	Public Beta1FromOrthogonalRegression As Double
	Public Beta0FromOrthogonalRegression As Double
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
End Sub

Public Sub calc(pxypoints As List)
	Dim n As Int = pxypoints.Size
	Sx = 0
	Sy = 0
	
	Dim sb As StringBuilder
	sb.Initialize

	For Each XY() As Double In pxypoints
		Dim x As Double = XY(0)
		Dim y As Double = XY(1)
		Sx = Sx + x
		Sy = Sy + y
		sb.Append($"(${XY(0)},${XY(1)})"$)
	Next
	Log(sb.ToString)
	meanX = Sx / n
	meanY = Sy / n
	
	Sxx = 0
	Syy = 0
	Sxy = 0

	For Each XY() As Double In pxypoints
		Dim x As Double = XY(0)
		Dim y As Double = XY(1)
		Sxx = Sxx + Power(x-meanX,2)
		Syy = Syy + Power(y-meanY,2)
		Sxy = Sxy + (x - meanX) * (y - meanY)
	Next
	Beta1ForSimpleLinearRegression = Sxy/Sxx
	Beta0ForSimpleLinearRegression = meanY - Beta1ForSimpleLinearRegression * meanX
	
	Beta1FromGeometricMeanRegression =  Sign(Sxy)*Sqrt(Syy/Sxx)
	Beta0FromGeometricMeanRegression = meanY - Beta1FromGeometricMeanRegression * meanX
	
	Beta1FromOrthogonalRegression = (Syy-Sxx+Sqrt(Power(Syy-Sxx,2)+4*Power(Sxy,2))) / (2 * Sxy)
	Beta0FromOrthogonalRegression = meanY - Beta1FromOrthogonalRegression * meanX
	

End Sub

private Sub Sign(d As Double) As Int
	If d = 0 Then
		Return 0
	Else
		Return(d / Abs(d))
	End If
End Sub